%global debug_package %{nil}

Name:           mosdns
Version:        5.3.3
Release:        1%{?dist}
Summary:        mosdns is a plug-in DNS forwarder.
License:        GPL-3.0
URL:            https://github.com/IrineSistiana/mosdns

Source0:        %{name}-%{version}.tar.gz
Source1:        config.yaml
Source2:        mosdns.service
Source3:        mosdns@.service

# BuildRequires:  golang >= 1.20
# BuildRequires:  git-core
%{?systemd_requires}
Requires:       tzdata ca-certificates
Provides:       Productivity/Networking/DNS


%description
mosdns is a plug-in DNS forwarder.
Users can splicing plug-ins as needed to customize their own DNS processing logic.

%prep
%autosetup

%build
# https://pagure.io/go-rpm-macros/c/1cc7f5d9026175bb6cb1b8c889355d0c4fc0e40a
%undefine _auto_set_build_flags

LDFLAGS="-X main.version=v%{version} -s -w -buildid="
env CGO_ENABLED=0 go build -v -trimpath -ldflags "${LDFLAGS}" -o %{name}


%install
%{__install} -d %{buildroot}%{_bindir}
%{__install} -p -m 755 %{name} %{buildroot}%{_bindir}

%{__install} -d %{buildroot}%{_sysconfdir}/%{name}
%{__install} -p -m 644 %{S:1} %{buildroot}%{_sysconfdir}/%{name}/config.yaml

%{__install} -d %{buildroot}%{_unitdir}
%{__install} -p -m 644 %{S:2} %{buildroot}%{_unitdir}/%{name}.service
%{__install} -p -m 644 %{S:3} %{buildroot}%{_unitdir}/%{name}@.service

%{__install} -d %{buildroot}%{_sharedstatedir}/%{name}

# shell completions
%{__install} -d -m 0755 %{buildroot}%{_datadir}/bash-completion/completions
./%{name} completion bash > %{buildroot}%{_datadir}/bash-completion/completions/%{name}
%{__install} -d -m 0755 %{buildroot}%{_datadir}/zsh/site-functions
./%{name} completion zsh > %{buildroot}%{_datadir}/zsh/site-functions/_%{name}
%{__install} -d -m 0755 %{buildroot}%{_datadir}/fish/vendor_completions.d
./%{name} completion fish > %{buildroot}%{_datadir}/fish/vendor_completions.d/%{name}.fish


%post
%systemd_post %{name}.service

%preun
%systemd_preun %{name}.service

%postun
%systemd_postun_with_restart %{name}.service

%files
%{_bindir}/%{name}
%{_unitdir}/%{name}.service
%{_unitdir}/%{name}@.service
%dir %{_sysconfdir}/%{name}
%dir %{_sharedstatedir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/config.yaml
%{_datadir}/bash-completion/completions/%{name}
%{_datadir}/zsh/site-functions/_%{name}
%{_datadir}/fish/vendor_completions.d/%{name}.fish
%license LICENSE
%doc README.md

%changelog
* Thu Aug 15 2024 Teddysun <i@teddysun.com> - 5.3.3-1
- Update version to 5.3.3

* Tue Dec 19 2023 Teddysun <i@teddysun.com> - 5.3.1-1
- Initial version 5.3.1
